/*
 * Copyright 2017 Arne Vajhj.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License. 
 */

package dk.vajhoej.vms.acct;

import dk.vajhoej.record.InfoProvider;
import dk.vajhoej.record.LengthProvider2;

/**
 * Class AcctPackProvider provides lengths for various variable length items in accounting packets.
 */
public class AcctPackProvider implements InfoProvider {
	public int getLength(Object o, int n) {
		return -1; // ignore
	}
	public int getMaxLength() {
		return 32767; // VMS max variable length record
	}
	public int getElements(Object o, int n) {
		if(o instanceof AcctPackID && n == 19) {
			return ((AcctPackID)o).getLength() - 50; // take remaining fields in a single byte[]
		} else {
			return -1; // ignore
		}
	}
	public LengthProvider2 getLengthProvider(Object o, int n) {
		return null; // ignore
	}
	public boolean hasConvertSelector() {
		return true;
	}
	public int convertSelector(Object o) {
		return ((AcctPackType) o).getType();
	}
}
