/*
 * Copyright 2017 Arne Vajhj.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License. 
 */

package dk.vajhoej.vms.acct.test;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintStream;

import dk.vajhoej.record.RecordException;
import dk.vajhoej.record.Util2;
import dk.vajhoej.record.Util2.ObjectHandler;
import dk.vajhoej.vms.acct.AcctRec;
import dk.vajhoej.vms.acct.AcctRecProvider;;

public class Test {
	private static int n = 0;
	public static void main(String[] args) {
		try {
			long t1 = System.currentTimeMillis();
			final PrintStream ps = new PrintStream(new FileOutputStream(args[1]));
			InputStream is = new FileInputStream(args[0]);
			Util2.readAll(AcctRec.class, 
				is,
				new ObjectHandler<AcctRec>() {
					public void process(AcctRec o) throws RecordException, IOException {
						ps.println(o);
						n++;
					}
				},
				new AcctRecProvider());
			is.close();
			ps.close();
			long t2 = System.currentTimeMillis();
			System.out.println(n + " records in " + (t2 - t1) + " milliseconds");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
